##### The Red Book (v0.704442)
##### Scripts for Chapter 8
#####


### Preamble
source("http://rfs.kvasaheim.com/rfs.R")





##### ##### ##### ##### #####
### Example 8.1 (p258)

## Preamble

# Read in data
cow = read.csv("http://rur.kvasaheim.com/data/cows.csv")
names(cow)
attach(cow)

## GLM Model
model.1 = glm(propWin ~ yearPassed + chickens + religPct)
summary(model.1)

# Prediction for Decin
DECIN = data.frame(yearPassed=9, chickens=0, religPct=48)
predict(model.1, newdata=DECIN)


## Logit model
mod3 = glm(propWin ~ yearPassed + chickens + religPct, family=gaussian(link=make.link("logit")))
summary(mod3)

detach(cow)
rm(list=ls())





##### ##### ##### ##### #####
### Example 8.2 (p261)

## Preamble
gdp = read.csv("http://rur.kvasaheim.com/data/gdpcap.csv")
names(gdp)
attach(gdp)

## OLS Model
m1 = lm(log(gdpcap) ~ democracy + hig)

## GLM Model
m2 = glm(gdpcap ~ democracy + hig, family=gaussian(link = make.link("log")))
summary(m2)

# OR
glm(gdpcap ~ democracy + hig, family=gaussian(link="log"))

# Papua New Guina
PNG = data.frame(hig=2.1, democracy=10)
exp(predict(m2, newdata=PNG))



### Figure 8.2 (p263)

# Prepare
xnew <- 0:100/10
pr1 <- exp( predict(m1, newdata=data.frame(democracy=10,hig=xnew)) )
pr2 <- exp( predict(m2, newdata=data.frame(democracy=10,hig=xnew)) )

# Graphic
par(family="serif",las=1)
par(mar=c(4,4,0,0)+0.5)
par(cex.lab=1.1,font.lab=2)
par(xaxs="i",yaxs="i")

plot.new()
plot.window(xlim=c(0,10), ylim=c(0,100) )

points(hig,gdpcap/1000, pch=21, bg="dodgerblue")

lines(xnew,pr1/1000, lwd=2, col="green4")
lines(xnew,pr2/1000, lwd=2, col="purple4")

axis(1, at=0:10)
axis(2, at=seq(0,150,10))

title(xlab="Level of Honesty in Government", line=2.5)
title(ylab="GDP per Capita [in $1000s]", line=3)

legend("topleft",c("Classical Linear Model","Generalized Linear Model"),
	lwd=2, col=c("green4","purple4"),bty="n")


# Identify Papua New Guinea
m1est = exp( predict(m1, newdata=PNG) )
m2est = exp( predict(m2, newdata=PNG) )

points( PNG[1,"hig"], m1est/1000, pch=13, cex=3, lwd=2 )
points( PNG[1,"hig"], m2est/1000, pch=13, cex=3, lwd=2 )







#####
##### ##### ##### ##### #####
#####
