##### The Red Book (v0.704442)
##### Scripts for Appendix S: Statistics
#####




##### ##### ##### ##### ##### 
### Example 19.5 (p458)


# What are runs?
x = c(1.2,3.5,-0.5,8.9,-1.2,-1.6,-4.5,0.6,1.5,-7.9)
sign(x)

# 6 runs here





##### ##### ##### ##### ##### 
### Runs Distribution (p458)

# parameter and function
resids = 20

calculateRuns = function(x) {
  n = length(x)
  y = x[-n]-x[-1]
runs = 1+sum(y!=0)
}

# MS: Estimated Distribution
numRuns = numeric()

for(i in 1:1e6) {
  x = sign( rnorm(resids) )
  numRuns[i] = calculateRuns(x)
}

## confidence interval
quantile(numRuns, c(0.05))

## Calculate p-value, given observed = 3
mean(numRuns<=3)


### Figure S.1
par(mar=c(3,0,0,0)+1)
par(yaxt="n")
par(family="serif")
par(font.lab=2,cex.lab=1.1)

barplot(table(numRuns), col=rgb(0.8509804, 0.3725490, 0.007843137) )
abline(h=0)

title(xlab="Number of Runs", line=2.75)








#####
##### ##### ##### ##### #####
#####
